OSDN Git Service

(sys/types.h): Check for [ \t]size_t not size_t.
[pf3gnuchains/gcc-fork.git] / gcc / fixincludes
1 #! /bin/sh
2 # Install modified versions of certain ANSI-incompatible system header files
3 # which are fixed to work correctly with ANSI C
4 # and placed in a directory that GNU C will search.
5
6 # See README-fixinc for more information.
7
8 # Directory where gcc sources (and sometimes special include files) live.
9 # fixincludes doesn't use this, but fixinc.svr4 does, and I want to make
10 # sure somebody doesn't try to use arg3 for something incompatible. -- gumby
11 SRCDIR=${3-${SRCDIR-.}}
12
13 # Directory containing the original header files.
14 # (This was named INCLUDES, but that conflicts with a name in Makefile.in.)
15 INPUT=${2-${INPUT-/usr/include}}
16
17 # This prevents /bin/ex from failing if the current terminal type is
18 # unrecognizable.
19 TERM=unknown
20 export TERM
21 # This prevents two problems:
22 # Either ex might find a .exrc file and get confused,
23 # or ex might complain if the EXINIT variable is invalid. 
24 # We know there is no .exrc in the GCC source.
25 # `set' is a no-op ex command.
26 EXINIT=set
27 export EXINIT
28
29 # Define PWDCMD as a command to use to get the working dir
30 # in the form that we want.
31 PWDCMD=pwd
32 case "`pwd`" in
33 //*)
34         # On an Apollo, discard everything before `/usr'.
35         PWDCMD="eval pwd | sed -e 's,.*/usr/,/usr/,'"
36         ;;
37 esac
38
39 # Directory in which to store the results.
40 LIB=${1?"fixincludes: output directory not specified"}
41
42 # Make sure it exists.
43 if [ ! -d $LIB ]; then
44   mkdir $LIB || exit 1
45 fi
46
47 # Make LIB absolute.
48 cd $LIB; LIB=`${PWDCMD}`
49
50 # Fail if no arg to specify a directory for the output.
51 if [ x$1 = x ]
52 then echo fixincludes: no output directory specified
53 exit 1
54 fi
55
56 echo Building fixed headers in ${LIB}
57
58 # Determine whether this system has symbolic links.
59 if ln -s X $LIB/ShouldNotExist 2>/dev/null; then
60   rm -f $LIB/ShouldNotExist
61   LINKS=true
62 else
63   LINKS=false
64 fi
65
66 echo Finding directories and links to directories
67 cd ${INPUT}
68 # Find all directories and all symlinks that point to directories.
69 # Put the list in $files.
70 # Each time we find a symlink, add it to newdirs
71 # so that we do another find within the dir the link points to.
72 # Note that $files may have duplicates in it;
73 # later parts of this file are supposed to ignore them.
74 dirs="."
75 levels=2
76 while [ -n "$dirs" ] && [ $levels -gt 0 ]
77 do
78     levels=`expr $levels - 1`
79     newdirs=
80     for d in $dirs
81     do
82         echo " Searching $INPUT/$d"
83         if [ "$d" != . ]
84         then
85             d=$d/.
86         fi
87
88         # Find all directories under $d, relative to $d, excluding $d itself.
89         files="$files `find $d -type d -print | \
90                        sed -e '/\/\.$/d' -e '/^\.$/d'`"
91         # Find all links to directories.
92         # Using `-exec test -d' in find fails on some systems,
93         # and trying to run test via sh fails on others,
94         # so this is the simplest alternative left.
95         # First find all the links, then test each one.
96         theselinks=
97         $LINKS && \
98           theselinks=`find $d -type l -print`
99         for d1 in $theselinks --dummy--
100         do
101             # If the link points to a directory,
102             # add that dir to $newdirs
103             if [ -d $d1 ]
104             then
105                 newdirs="$newdirs $d1"
106             fi
107         done
108     done
109
110     files="$files $newdirs"
111     dirs="$newdirs"
112 done
113
114 dirs=
115 echo "All directories (including links to directories):"
116 echo $files
117
118 for file in $files; do
119   rm -rf $LIB/$file
120   if [ ! -d $LIB/$file ]
121   then mkdir $LIB/$file
122   fi
123 done
124 mkdir $LIB/root
125
126 # treetops gets an alternating list
127 # of old directories to copy
128 # and the new directories to copy to.
129 treetops="${INPUT} ${LIB}"
130
131 if $LINKS; then
132   echo 'Making symbolic directory links'
133   for file in $files; do
134     dest=`ls -ld $file | sed -n 's/.*-> //p'`
135     if [ "$dest" ]; then    
136       cwd=`${PWDCMD}`
137       # In case $dest is relative, get to $file's dir first.
138       cd ${INPUT}
139       cd `echo ./$file | sed -n 's&[^/]*$&&p'`
140       # Check that the target directory exists.
141       # Redirections changed to avoid bug in sh on Ultrix.
142       (cd $dest) > /dev/null 2>&1
143       if [ $? = 0 ]; then
144         cd $dest
145         # X gets the dir that the link actually leads to.
146         x=`${PWDCMD}`
147         # If a link points to ., make a similar link to .
148         if [ $x = $INPUT ]; then
149           echo $file '->' . ': Making link'
150           rm -fr ${LIB}/$file > /dev/null 2>&1
151           ln -s . ${LIB}/$file > /dev/null 2>&1
152         # If link leads back into ${INPUT},
153         # make a similar link here.
154         elif expr $x : "${INPUT}/.*" > /dev/null; then
155           # Y gets the actual target dir name, relative to ${INPUT}.
156           y=`echo $x | sed -n "s&${INPUT}/&&p"`
157           echo $file '->' $y ': Making link'
158           rm -fr ${LIB}/$file > /dev/null 2>&1
159           ln -s ${LIB}/$y ${LIB}/$file > /dev/null 2>&1
160         else
161           # If the link is to a dir $target outside ${INPUT},
162           # repoint the link at ${INPUT}/root$target
163           # and process $target into ${INPUT}/root$target
164           # treat this directory as if it actually contained the files.
165           echo $file '->' root$x ': Making link'
166           if [ -d $LIB/root$x ]
167           then true
168           else
169             dirname=root$x/
170             dirmade=.
171             cd $LIB
172             while [ x$dirname != x ]; do
173               component=`echo $dirname | sed -e 's|/.*$||'`
174               mkdir $component >/dev/null 2>&1
175               cd $component
176               dirmade=$dirmade/$component
177               dirname=`echo $dirname | sed -e 's|[^/]*/||'`
178             done
179           fi
180           rm -fr ${LIB}/$file > /dev/null 2>&1
181           ln -s ${LIB}/root$x ${LIB}/$file > /dev/null 2>&1
182           treetops="$treetops $x ${LIB}/root$x"
183         fi
184       fi
185       cd $cwd
186     fi
187   done
188 fi
189
190 set - $treetops
191 while [ $# != 0 ]; do
192   # $1 is an old directory to copy, and $2 is the new directory to copy to.
193   cd ${INPUT}
194   cd $1
195 # The same dir can appear more than once in treetops.
196 # There's no need to scan it more than once.
197   if [ -f $2/DONE ]
198   then
199     files=
200   else
201     touch $2/DONE
202     echo Fixing directory $1 into $2
203 # Check .h files which are symlinks as well as those which are files.
204 # A link to a header file will not be processed by anything but this.
205     if $LINKS; then
206       files=`find . -name '*.h' \( -type f -o -type l \) -print`
207     else
208       files=`find . -name '*.h' -type f -print`
209     fi
210     echo Checking header files
211   fi
212 # Note that BSD43_* are used on recent MIPS systems.
213   for file in $files; do
214 # This call to egrep is essential, since checking a file with egrep
215 # is much faster than actually trying to fix it.
216 # It is also essential that most files *not* match!
217 # Thus, matching every #endif is unacceptable.
218 # But the argument to egrep must be kept small, or many versions of egrep
219 # won't be able to handle it.
220 # rms: I removed `|#[el].*if.*[^/       ]' because it made egrep fail.
221     if egrep '//|[      _]_IO|CTRL|#define.NULL|#[el]*if.*([0-9]|sparc|vax|sun|pyr)' $file > /dev/null; then
222       echo Fixing $file
223       if [ -r $file ]; then
224         cp $file $2/$file >/dev/null 2>&1       \
225         || echo "Can't copy $file"
226         chmod +w $2/$file
227 # Following two lines removed.
228 #         s%^\([        ]*#[    ]*endif[        ]*\)\([^/       ].*\)$%\1/* \2 */%
229 #         s%^\([        ]*#[    ]*else[         ]*\)\([^/       ].*\)$%\1/* \2 */%
230
231         sed -e '
232                                    :loop
233           /\\$/                 N
234           /\\$/                 b loop
235           /\/\//                        s|//\(.*\)$|/*\1*/|
236           /[    ]_IO[A-Z]*[     ]*(/    s/(\(.\),/('\''\1'\'',/
237           /[    ]BSD43__IO[A-Z]*[       ]*(/    s/(\(.\),/('\''\1'\'',/
238           /#define._IO/                 s/'\''x'\''/x/g
239           /#define.BSD43__IO/           s/'\''x'\''/x/g
240           /[^A-Z]CTRL[  ]*(/            s/\([^'\'']\))/'\''\1'\'')/
241           /#define.CTRL/                s/'\''c'\''/c/g
242           /#define._CTRL/               s/'\''c'\''/c/g
243           /#define.BSD43_CTRL/          s/'\''c'\''/c/g
244           /#[a-z]*if.*[  (]m68k/        s/\([^_]\)m68k/\1__m68k__/g
245           /#[a-z]*if.*[  (]__i386/      s/__i386/__i386__/g
246           /#[a-z]*if.*[  (]i386/        s/\([^_]\)i386/\1__i386__/g
247           /#[a-z]*if.*[  (]sparc/       s/\([^_]\)sparc/\1__sparc__/g
248           /#[a-z]*if.*[  (]mc68000/     s/\([^_]\)mc68000/\1__mc68000__/g
249           /#[a-z]*if.*[  (]vax/         s/\([^_]\)vax/\1__vax__/g
250           /#[a-z]*if.*[  (]sun/         s/\([^_]\)\(sun[a-z0-9]*\)\([^a-z0-9_]\)/\1__\2__\3/g
251           /#[a-z]*if.*[  (]sun/         s/\([^_]\)\(sun[a-z0-9]*\)$/\1__\2__/g
252           /#[a-z]*if.*[  (]ns32000/     s/\([^_]\)ns32000/\1__ns32000__/g
253           /#[a-z]*if.*[  (]pyr/         s/\([^_]\)pyr/\1__pyr__/g
254           /#[a-z]*if.*[  (]is68k/       s/\([^_]\)is68k/\1__is68k__/g
255           /^#define.NULL[       ]/      i\
256                 #undef NULL
257         ' $2/$file > $2/$file.sed
258         mv $2/$file.sed $2/$file
259         if cmp $file $2/$file >/dev/null 2>&1; then
260            echo Deleting $2/$file\; no fixes were needed.
261            rm $2/$file
262         fi
263       fi
264     fi
265   done
266   shift; shift
267 done
268
269 cd ${INPUT}
270
271 # Fix one other error in this file: a mismatched quote not inside a C comment.
272 file=sundev/vuid_event.h
273 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
274   mkdir ${LIB}/sundev 2>/dev/null
275   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
276   chmod +w ${LIB}/$file 2>/dev/null
277 fi
278
279 if [ -r ${LIB}/$file ]; then
280   echo Fixing $file comment
281   ex ${LIB}/$file <<EOF
282   g/doesn't/s/doesn't/does not/
283   wq
284 EOF
285   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
286     echo Deleting ${LIB}/$file\; no fixes were needed.
287     rm ${LIB}/$file
288   fi
289 fi
290
291 # Fix this Sun file to avoid interfering with stddef.h.
292 file=sys/stdtypes.h
293 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
294   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
295   chmod +w ${LIB}/$file 2>/dev/null
296 fi
297
298 if [ -r ${LIB}/$file ]; then
299   echo Fixing $file
300   ex ${LIB}/$file <<EOF
301   /size_t.*;/
302   i
303 #ifndef _GCC_SIZE_T
304 #define _GCC_SIZE_T
305 .
306   /size_t/+1
307   i
308 #endif
309 .
310   /ptrdiff_t.*;/
311   i
312 #ifndef _GCC_PTRDIFF_T
313 #define _GCC_PTRDIFF_T
314 .
315   /ptrdiff_t/+1
316   i
317 #endif
318 .
319   /wchar_t.*;/
320   i
321 #ifndef _GCC_WCHAR_T
322 #define _GCC_WCHAR_T
323 .
324   /wchar_t/+1
325   i
326 #endif
327 .
328   wq
329 EOF
330   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
331     echo Deleting ${LIB}/$file\; no fixes were needed.
332     rm ${LIB}/$file
333   fi
334 fi
335
336 # Fix this file to avoid interfering with stddef.h, but don't mistakenly
337 # match e.g. ssize_t present in AIX for the ps/2.
338 file=sys/types.h
339 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
340   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
341   chmod +w ${LIB}/$file 2>/dev/null
342 fi
343
344 if [ -r ${LIB}/$file ]; then
345   echo Fixing $file
346   ex ${LIB}/$file <<EOF
347   /typedef.*[   ]size_t.*;/
348   i
349 #ifndef _GCC_SIZE_T
350 #define _GCC_SIZE_T
351 .
352   /size_t/+1
353   i
354 #endif
355 .
356   wq
357 EOF
358   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
359     echo Deleting ${LIB}/$file\; no fixes were needed.
360     rm ${LIB}/$file
361   fi
362 fi
363
364 # Fix an error in this file: a missing semi-colon at the end of the statsswtch
365 # structure definition.
366 file=rpcsvc/rstat.h
367 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
368   mkdir ${LIB}/rpcsvc 2>/dev/null
369   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
370   chmod +w ${LIB}/$file 2>/dev/null
371 fi
372
373 if [ -r ${LIB}/$file ]; then
374   echo Fixing $file, definition of statsswtch
375   ex ${LIB}/$file <<EOF
376   g/boottime$/s//&;/
377   wq
378 EOF
379   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
380     echo Deleting ${LIB}/$file\; no fixes were needed.
381     rm ${LIB}/$file
382   fi
383 fi
384
385 # Fix an error in this file: a missing semi-colon at the end of the nodeent
386 # structure definition.
387 file=netdnet/dnetdb.h
388 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
389   mkdir ${LIB}/netdnet 2>/dev/null
390   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
391   chmod +w ${LIB}/$file 2>/dev/null
392 fi
393
394 if [ -r ${LIB}/$file ]; then
395   echo Fixing $file, definition of nodeent
396   ex ${LIB}/$file <<EOF
397   g/char.*na_addr *$/s//&;/
398   wq
399 EOF
400   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
401     echo Deleting ${LIB}/$file\; no fixes were needed.
402     rm ${LIB}/$file
403   fi
404 fi
405
406 # Check for bad #ifdef line (in Ultrix 4.1)
407 file=sys/file.h
408 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
409   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
410   chmod +w ${LIB}/$file 2>/dev/null
411 fi
412
413 if [ -r ${LIB}/$file ]; then
414   echo Fixing $file, bad \#ifdef line
415   ex ${LIB}/$file <<EOF
416   g/^#ifdef KERNEL && !defined/
417   s/#ifdef KERNEL && !defined/#if defined(KERNEL) \&\& !defined/
418   wq
419 EOF
420   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
421     echo Deleting ${LIB}/$file\; no fixes were needed.
422     rm ${LIB}/$file
423   fi
424 fi
425
426 # Remove nested comments created by #endifs in a comment (Ultrix 4.1)
427 # Only needed if commenting out junk after #endif.
428 #file=signal.h
429 #if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
430 #  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
431 #  chmod +w ${LIB}/$file 2>/dev/null
432 #fi
433 #
434 #if [ -r ${LIB}/$file ]; then
435 #  echo Fixing $file, nested comments
436 #  sed -e 's/#endif.*/#endif/' ${LIB}/$file > ${LIB}/${file}.sed
437 #  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
438 #  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
439 #    echo Deleting ${LIB}/$file\; no fixes were needed.
440 #    rm -f ${LIB}/$file
441 #  fi
442 #fi
443
444 # Check for superfluous `static' (in Ultrix 4.2)
445 file=machine/cpu.h
446 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
447   mkdir ${LIB}/machine 2>/dev/null
448   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
449   chmod +w ${LIB}/$file 2>/dev/null
450 fi
451
452 if [ -r ${LIB}/$file ]; then
453   echo Fixing $file, superfluous static
454   ex ${LIB}/$file <<EOF
455   g/^static struct tlb_pid_state/
456   s/static//
457   wq
458 EOF
459   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
460     echo Deleting ${LIB}/$file\; no fixes were needed.
461     rm ${LIB}/$file
462   else
463 # This file has an alternative name, mips/cpu.h.  Fix that name, too.
464     if cmp machine/cpu.h mips/cpu.h > /dev/null 2>& 1; then
465       mkdir ${LIB}/mips 2>&-
466       ln ${LIB}/$file ${LIB}/mips/cpu.h 
467     fi
468   fi
469 fi
470
471 # Incorrect sprintf declaration in X11/Xmu.h
472 file=X11/Xmu.h
473 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
474   mkdir ${LIB}/X11 2>/dev/null
475   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
476   chmod +w ${LIB}/$file 2>/dev/null
477 fi
478
479 if [ -r ${LIB}/$file ]; then
480   echo Fixing $file sprintf declaration
481   ex ${LIB}/$file <<EOF
482   /^extern char \*      sprintf();$/c
483 #ifndef __STDC__
484 extern char *   sprintf();
485 #endif /* !defined __STDC__ */
486 .
487   wq
488 EOF
489   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
490     echo Deleting ${LIB}/$file\; no fixes were needed.
491     rm ${LIB}/$file
492   fi
493 fi
494
495 # Incorrect sprintf declaration in X11/Xmu/Xmu.h
496 # (It's not clear whether the right file name is this or X11/Xmu.h.)
497 file=X11/Xmu/Xmu.h
498 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
499   mkdir ${LIB}/X11/Xmu 2>/dev/null
500   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
501   chmod +w ${LIB}/$file 2>/dev/null
502 fi
503
504 if [ -r ${LIB}/$file ]; then
505   echo Fixing $file sprintf declaration
506   ex ${LIB}/$file <<EOF
507   /^extern char \*      sprintf();$/c
508 #ifndef __STDC__
509 extern char *   sprintf();
510 #endif /* !defined __STDC__ */
511 .
512   wq
513 EOF
514   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
515     echo Deleting ${LIB}/$file\; no fixes were needed.
516     rm ${LIB}/$file
517   fi
518 fi
519
520 # Check for missing ';' in struct
521 file=netinet/ip.h
522 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
523   mkdir ${LIB}/netinet 2>/dev/null
524   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
525   chmod +w ${LIB}/$file 2>/dev/null
526 fi
527
528 if [ -r ${LIB}/$file ]; then
529   echo Fixing $file
530   sed -e '/^struct/,/^};/s/}$/};/' ${LIB}/$file > ${LIB}/${file}.sed
531   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
532   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
533     echo Deleting ${LIB}/$file\; no fixes were needed.
534     rm -f ${LIB}/$file
535   fi
536 fi
537
538 # Fix the CAT macro in SunOS memvar.h.
539 file=pixrect/memvar.h
540 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
541   mkdir ${LIB}/pixrect 2>/dev/null
542   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
543   chmod +w ${LIB}/$file 2>/dev/null
544 fi
545
546 if [ -r ${LIB}/$file ]; then
547   echo Fixing $file
548   sed -e '/^#define.CAT(a,b)/ i\
549 #ifdef __STDC__ \
550 #define CAT(a,b) a##b\
551 #else
552 /^#define.CAT(a,b)/ a\
553 #endif
554 ' ${LIB}/$file > ${LIB}/${file}.sed
555   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
556   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
557     echo Deleting ${LIB}/$file\; no fixes were needed.
558     rm -f ${LIB}/$file
559   fi
560 fi
561
562 # Check for yet more missing ';' in struct (in SunOS 4.0.x)
563 file=rpcsvc/rusers.h
564 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
565   mkdir ${LIB}/rpcsvc 2>/dev/null
566   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
567   chmod +w ${LIB}/$file 2>/dev/null
568 fi
569
570 if [ -r ${LIB}/$file ]; then
571   echo Fixing $file
572   sed -e '/^struct/,/^};/s/_cnt$/_cnt;/' ${LIB}/$file > ${LIB}/${file}.sed
573   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
574   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
575     echo Deleting ${LIB}/$file\; no fixes were needed.
576     rm -f ${LIB}/$file
577   fi
578 fi
579
580 # Fix return type of exit and abort in <stdlib.h> on SunOS 4.1.
581 file=stdlib.h
582 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
583   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
584   chmod +w ${LIB}/$file 2>/dev/null
585 fi
586
587 if [ -r ${LIB}/$file ]; then
588   echo Fixing $file
589   sed -e 's/int abort/void      abort/g' \
590   -e 's/int     free/void       free/g' \
591   -e 's/char \* calloc/void \*  calloc/g' \
592   -e 's/char \* malloc/void \*  malloc/g' \
593   -e 's/char \* realloc/void \* realloc/g' \
594   -e 's/int     exit/void       exit/g' ${LIB}/$file > ${LIB}/${file}.sed
595   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
596   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
597     echo Deleting ${LIB}/$file\; no fixes were needed.
598     rm -f ${LIB}/$file
599   fi
600 fi
601
602 # Fix return type of free and {c,m,re}alloc in <malloc.h> on SunOS 4.1.
603 file=malloc.h
604 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
605   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
606   chmod +w ${LIB}/$file 2>/dev/null
607 fi
608
609 if [ -r ${LIB}/$file ]; then
610   echo Fixing $file
611   sed -e 's/typedef[    ]char \*        malloc_t/typedef void \*        malloc_t/g' \
612   -e 's/int[    ][      ]*free/void     free/g' \
613   ${LIB}/$file > ${LIB}/${file}.sed
614   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
615   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
616     echo Deleting ${LIB}/$file\; no fixes were needed.
617     rm -f ${LIB}/$file
618   fi
619 fi
620
621
622 # Fix bogus comment in <locale.h> on SunOS 4.1.
623 file=locale.h
624 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
625   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
626   chmod +w ${LIB}/$file 2>/dev/null
627 fi
628
629 if [ -r ${LIB}/$file ]; then
630   echo Fixing $file
631   sed -e 's%#endif / \*%#endif /\* %g' ${LIB}/$file > ${LIB}/${file}.sed
632   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
633   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
634     echo Deleting ${LIB}/$file\; no fixes were needed.
635     rm -f ${LIB}/$file
636   fi
637 fi
638
639 # Fix bogus #ifdef in <hsfs/hsfs_spec.h> on SunOS 4.1.
640 file=hsfs/hsfs_spec.h
641 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
642   mkdir ${LIB}/hsfs 2>/dev/null
643   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
644   chmod +w ${LIB}/$file 2>/dev/null
645 fi
646
647 if [ -r ${LIB}/$file ]; then
648   echo Fixing $file
649   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
650     ${LIB}/$file > ${LIB}/${file}.sed
651   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
652   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
653     echo Deleting ${LIB}/$file\; no fixes were needed.
654     rm -f ${LIB}/$file
655   fi
656 fi
657
658 # Fix bogus #ifdef in <hsfs/hsnode.h> on SunOS 4.1.
659 file=hsfs/hsnode.h
660 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
661   mkdir ${LIB}/hsfs 2>/dev/null
662   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
663   chmod +w ${LIB}/$file 2>/dev/null
664 fi
665
666 if [ -r ${LIB}/$file ]; then
667   echo Fixing $file
668   sed -e 's/\#ifdef __i386__ || __sun4c__/\#if __i386__ || __sun4c__/g' \
669     ${LIB}/$file > ${LIB}/${file}.sed
670   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
671   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
672     echo Deleting ${LIB}/$file\; no fixes were needed.
673     rm -f ${LIB}/$file
674   fi
675 fi
676
677 # Fix bogus #ifdef in <hsfs/iso_spec.h> on SunOS 4.1.
678 file=hsfs/iso_spec.h
679 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
680   mkdir ${LIB}/hsfs 2>/dev/null
681   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
682   chmod +w ${LIB}/$file 2>/dev/null
683 fi
684
685 if [ -r ${LIB}/$file ]; then
686   echo Fixing $file
687   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
688     ${LIB}/$file > ${LIB}/${file}.sed
689   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
690   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
691     echo Deleting ${LIB}/$file\; no fixes were needed.
692     rm -f ${LIB}/$file
693   fi
694 fi
695
696 # Incorrect #include in Sony News-OS 3.2.
697 file=machine/machparam.h
698 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
699   mkdir ${LIB}/machine 2>/dev/null
700   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
701   chmod +w ${LIB}/$file 2>/dev/null
702 fi
703
704 if [ -r ${LIB}/$file ]; then
705   echo Fixing $file, incorrect \#include
706   sed -e 's@"../machine/endian.h"@<machine/endian.h>@' \
707     ${LIB}/$file > ${LIB}/${file}.sed
708   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
709   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
710     echo Deleting ${LIB}/$file\; no fixes were needed.
711     rm -f ${LIB}/$file
712   fi
713 fi
714
715 # Multiline comment after typedef on IRIX 4.0.1.
716 file=sys/types.h
717 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
718   mkdir ${LIB}/sys 2>/dev/null
719   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
720   chmod +w ${LIB}/$file 2>/dev/null
721 fi
722
723 if [ -r ${LIB}/$file ]; then
724   echo Fixing $file, comment in the middle of \#ifdef
725   sed -e 's@type of the result@type of the result */@' \
726     -e 's@of the sizeof@/* of the sizeof@' \
727     ${LIB}/$file > ${LIB}/${file}.sed
728   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
729   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
730     echo Deleting ${LIB}/$file\; no fixes were needed.
731     rm -f ${LIB}/$file
732   fi
733 fi
734
735 # Fix non-ANSI memcpy declaration that conflicts with gcc's builtin
736 # declaration on Sun OS 4.x.  We must only fix this on Sun OS 4.x, because
737 # many other systems have similar text but correct versions of the file.
738 # To ensure only Sun's is fixed, we grep for a likely unique string.
739 file=memory.h
740 if egrep '/\*   @\(#\)memory\.h 1\.[2-4] 8./../.. SMI; from S5R2 1\.2   \*/' $file > /dev/null; then
741   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
742     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
743     chmod +w ${LIB}/$file 2>/dev/null
744   fi
745   if [ -r ${LIB}/$file ]; then
746     echo Replacing $file
747     cat > ${LIB}/$file << EOF
748 /* This file was generated by fixincludes */
749 #ifndef __memory_h__
750 #define __memory_h__
751
752 #ifdef __STDC__
753 extern void *memccpy();
754 extern void *memchr();
755 extern void *memcpy();
756 extern void *memset();
757 #else
758 extern char *memccpy();
759 extern char *memchr();
760 extern char *memcpy();
761 extern char *memset();
762 #endif /* __STDC__ */
763
764 extern int memcmp();
765
766 #endif __memory_h__
767 EOF
768   fi
769 fi
770
771 # parameters not const on DECstation Ultrix V4.0.
772 file=stdio.h
773 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
774   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
775   chmod +w ${LIB}/$file 2>/dev/null
776 fi
777
778 if [ -r ${LIB}/$file ]; then
779   echo Fixing $file, non-const arg
780   sed -e 's@perror( char \*__s );@perror( const char *__s );@' \
781       -e 's@fputs( char \*__s,@fputs( const char *__s,@' \
782       -e 's@fopen( char \*__filename, char \*__type );@fopen( const char *__filename, const char *__type );@' \
783       -e 's@fwrite( void \*__ptr,@fwrite( const void *__ptr,@' \
784       -e 's@fscanf( FILE \*__stream, char \*__format,@fscanf( FILE *__stream, const char *__format,@' \
785       -e 's@scanf( char \*__format,@scanf( const char *__format,@' \
786       -e 's@sscanf( char \*__s, char \*__format,@sscanf( const char *__s, const char *__format,@' \
787     ${LIB}/$file > ${LIB}/${file}.sed
788   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
789   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
790     echo Deleting ${LIB}/$file\; no fixes were needed.
791     rm -f ${LIB}/$file
792   fi
793 fi
794
795 # Don't use or define the name va_list in stdio.h.
796 # This is for ANSI and also to interoperate properly with gvarargs.h.
797 file=stdio.h
798 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
799   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
800   chmod +w ${LIB}/$file 2>/dev/null
801 fi
802
803 if [ -r ${LIB}/$file ]; then
804   echo Fixing $file, use of va_list
805   # Arrange for stdio.h to use stdarg.h to define __gnuc_va_list
806   (echo "#define __need___va_list"
807    echo "#include <stdarg.h>") > ${LIB}/${file}.sed
808   # Use __gnuc_va_list in arg types in place of va_list.
809   # Define __va_list__ (something harmless and unused) instead of va_list.
810   # Don't claim to have defined va_list.
811   sed -e 's@ va_list @ __gnuc_va_list @' \
812       -e 's@ va_list@ __va_list__@' \
813       -e 's@\*va_list@*__va_list__@' \
814       -e 's@VA_LIST@DUMMY_VA_LIST@' \
815     ${LIB}/$file >> ${LIB}/${file}.sed
816   
817   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
818   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
819     echo Deleting ${LIB}/$file\; no fixes were needed.
820     rm -f ${LIB}/$file
821   fi
822 fi
823
824 # Cancel out ansi_compat.h on Ultrix.  Replace it with empty file.
825 file=ansi_compat.h
826 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
827   if grep -s ULTRIX $file; then
828     echo "/* This file intentionally left blank.  */" > $LIB/$file
829   fi
830 fi
831
832 # parameter to atof not const on DECstation Ultrix V4.0.
833 # also get rid of bogus inline definitions in HP-UX 8.0
834 file=math.h
835 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
836   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
837   chmod +w ${LIB}/$file 2>/dev/null
838 fi
839
840 if [ -r ${LIB}/$file ]; then
841   echo Fixing $file, non-const arg
842   sed -e 's@atof( char \*__nptr );@atof( const char *__nptr );@' \
843       -e 's@inline int abs(int d) { return (d>0)?d:-d; }@@' \
844       -e 's@inline double abs(double d) { return fabs(d); }@@' \
845     ${LIB}/$file > ${LIB}/${file}.sed
846   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
847   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
848     echo Deleting ${LIB}/$file\; no fixes were needed.
849     rm -f ${LIB}/$file
850   fi
851 fi
852
853 # These two files on SunOS 4 are included by other files
854 # in the same directory, using "...".  So we must make sure they exist
855 # in the same directory as the other fixed files.
856 if [ -r ${INPUT}/multimedia/audio_errno.h ]
857 then
858   ln -s ${INPUT}/multimedia/audio_errno.h ${LIB}/multimedia 2>/dev/null
859 fi
860 if [ -r ${INPUT}/multimedia/audio_hdr.h ]
861 then
862   ln -s ${INPUT}/multimedia/audio_hdr.h ${LIB}/multimedia 2>/dev/null
863 fi
864
865 echo 'Removing unneeded directories:'
866 cd $LIB
867 files=`find . -type d -print | sort -r`
868 for file in $files; do
869   rmdir $LIB/$file > /dev/null 2>&1
870 done
871
872 if $LINKS; then
873   echo 'Making internal symbolic non-directory links'
874   cd ${INPUT}
875   files=`find . -type l -print`
876   for file in $files; do
877     dest=`ls -ld $file | sed -n 's/.*-> //p'`
878     if expr "$dest" : '[^/].*' > /dev/null; then    
879       target=${LIB}/`echo file | sed "s|[^/]*\$|$dest|"`
880       if [ -f $target ]; then
881         ln -s $dest ${LIB}/$file >/dev/null 2>&1
882       fi
883     fi
884   done
885 fi
886
887 exit 0